import Vue from 'vue'

const mockSubmission = '//Procedural Programming technique shows creation of Pascal\'s Triangl\n' +
  '#include <iostream>\n' +
  '#include <iomanip>\n' +
  'using namespace std;\n' +
  'int** comb(int** a , int row , int col)\n' +
  '{\n' +
  '   int mid = col/2;\n' +
  '        //clear matrix\n' +
  '         for( int i = 0 ; i < row ; i++)\n' +
  '         for( int j = 0 ; j < col ; j++)\n' +
  '                a[i][j] = 0;\n' +
  '                a[0][mid] = 1; //put 1 in the middle of first row\n' +
  '    //build up Pascal\'s Triangle matrix\n' +
  '     for( int i = 1 ; i < row ; i++)\n' +
  '        {\n' +
  '          for( int j = 1 ; j < col - 1 ; j++)\n' +
  '               a[i][j] = a[i-1][j-1] + a[i-1][j+1];\n' +
  '        }\n' +
  '   return a;\n' +
  '}\n' +
  'void disp(int** ptr, int row, int col)\n' +
  '{\n' +
  '  cout << endl << endl;\n' +
  '    for ( int i = 0 ; i < row ; i++)\n' +
  '        {\n' +
  '        for ( int j = 0 ; j < col ; j++)\n'

const mockFeedback = {
  '1': 'Youre STUPID',
  '4': 'Very much so'
}

const submissionNotes = {
  state: {
    rawSubmission: '',
    feedback: {}
  },
  getters: {
    // reduce the string rawSubmission into an object where the keys are the
    // line indexes starting at one and the values the corresponding submission line
    // this makes iterating over the submission much more pleasant
    submission: state => {
      return state.rawSubmission.split('\n').reduce((acc, cur, index) => {
        acc[index + 1] = cur
        return acc
      }, {})
    }
  },
  mutations: {
    'SET_RAW_SUBMISSION': function (state, submission) {
      state.rawSubmission = mockSubmission
    },
    'SET_FEEDBACK': function (state, feedback) {
      state.feedback = feedback
    },
    'UPDATE_FEEDBACK': function (state, lineIndex, feedbackContent) {
      Vue.set(state.feedback, lineIndex, feedbackContent)
    }
  },
  actions: {
    // TODO remove mock data
    getSubmission (context, submissionId) {
      context.commit('SET_RAW_SUBMISSION', mockSubmission)
    },
    getFeedback (context, feedbackId) {
      context.commit('SET_FEEDBACK', mockFeedback)
    },
    updateFeedback (context, lineIndex, feedbackContent) {
      context.commit('UPDATE_FEEDBACK', lineIndex, feedbackContent)
    }
  }
}

export default submissionNotes
